
' Universalzahler 5A
' 16.08.2011
'------------------- Funktion --------------------------------------------------
' Mit Timer1 wird ein Sekundentakt generiert
' Timer 0 wird zum Messen der Eingangsimpulse benutzt bei 255 Impulse wird
' die Unterroutine Timer_null angesprungen , dort wird der Timerwert mit dem
' berlaufwert multipliziert, weil Timer ja nur bis 255 zhlen kann.
' Gemmessen wird bei steigender Flanke
' Beim Eingangsimpuls soll eine Led angehen, das ist aber nicht so einfach
' lsbar weil timer nicht so direkt angesprochen werden kann, und die
' Interrupt routine nur alle 256 Impulse angesprungen wird.
' Also versuch ich es ber den weg des TCCR

  '------------- Fehler -------------------------------------------------------
  'Bei Nullstell Stellt Sich Nur Der Zhler Auf Null Nicht Aber Die Zeit



'
'
'--------------------- Allgemeine Prozessor Konfiguration ----------------------
$regfile "m8def.dat"     'Definiert den Atmega als Atmega8
$crystal = 1000000       'Gibt die Quarzfrequenz an in Herz
$hwstack = 32            'Default use 32 Hardware reservierte Speicher
$swstack = 10            'Default Software resvierung Speicher

' Konfiguration frs Display
Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portc.1 , Db7 = Portc.0 , Rs = Portc.5 , E = Portc.4
'--------------------------- I/O ----------------------------------------------
Ddrd = &B11100000        ' D5,D6,D7 als Ausgnge deklarieren
Ddrb = &B00000010        ' OC1A (B1) als Ausgang setzen
Portd = &B00011011       ' PullUp aktivieren pind.4 und d.0, d1 und d3


'-----------------   V a r i a b l e n    d e k la r i e r e n ----------------
Dim Voreinstellung As Word       ' Wert der Timer Voreinstellung
'Dim Zaehleingang As Word
Dim Ueberlaufwert As Long
Dim Ueberlaufwert_neu As Long

Dim Zaehlwert As Long
Dim Zaehlwert_neu As Long
Dim Z As Long
Dim Zz As Long

Dim Zeit As Word
Dim Nullstellen As Long
Dim Loeschen As Long
Dim Sekunden As Long
Dim Minute As Long
Dim Restzeit As Word
Dim Eprom_zeit As Eram Word
Dim P As Word
Dim Led_anzeige As Word
Dim Nullen As Word
Dim T As Bit
Dim Ton As String * 3


' -------------- V o r e i n s t e l l u n g  e n  ----------------------------
Voreinstellung = 49911   ' Voreinstellung fr 1 Sekunde beim Vorteiler 64

'Zeit = 1
Zeit = Eprom_zeit



'------------ T i m e r 0    K o n f i g u ri  e r e n ------------------------
'Eingang Timer 0(pind.4)wird Als Messeingang Benutzt , Dazu Muss Der Pullup
'Aktiviert Werden
'Timer 0 Kann Bis 256 Zhlen , Also Muss Jeder berlauf Separat Erfasst Und
'Hinzu Multizipliert Werden.
On Timer0 Timer_null

Tccr0 = &B00000111       ' Timer zhlt externe Signale mit steigender Flanke
Timsk.toie0 = 1          ' Interrupt fr Timer 0 aktivieren
' Die Globalen Interrupts werden schon bei Timer 1 aktiviert

'----------- T i m e r 1   k o n f i g u r i e r e n  -----_-------------------
Tccr1a = &B00000000      ' Kein Compare Modus
Tccr1b = &B00000011      ' Teilt Takt durch 64

Enable Timer1            ' Startet Timer 1
On Timer1 Timer_eins     ' Timer soll bei berlauf nach Routine Timer_eins gehen
Sreg.7 = 1               ' Globale Interrupts aktivieren
 Timsk.toie1 = 1         ' Interrupt fr Timer 1 aktivieren
Timer1 = Voreinstellung

'##################   H a u p t p r og r  a m m   #############################
Programm:
       Do
Led_anzeige = Timer0     ' Kopiert den Timerwert in Variable Ledanzeige
' Die Variable wird am Ende der Hauptprogrammschleife mit dem Timer verglichen
' sollte es einen unterschied geben also sollte der Timer in der Programm
' schkliefe weitergezhlt haben so geht die Blaue led an.

Portb.0 = 1              ' Rote Led als Betriebsanzeige an
Waitms 30                ' Zeit damit Rote Led leuchten kann
Portb.0 = 0              ' Rote led aus um Strom zu sparen


Z = Zaehlwert + Zaehlwert_neu
Zaehlwert = Timer0
If Pind.0 = 1 Then Goto Zeit
If Minute = Zeit Then Goto Messende

'-------------------------
'If Pind.4 = 0 Then Portd.5 = 1
Waitms 10
'Portd.5 = 0

' Else Portd.5 = 0       ' Led Blau  geht beim
' Eingangsimpuls an
'-------------------------

Restzeit = Zeit - Minute
'-----------------------
' Zhler wieder auf Null setzen
If Pind.1 = 0 Then Timer0 = 0
If Pind.1 = 0 Then Zaehlwert_neu = 0

' Damit nicht nur der Zhler zurck gestellt wird, sondern auch die Messzeit
' Wird bei tastendruck die im Eeprom abgespeicherte zeit wieder in Variable
' Zeit kopiert. Anschlieend wird eine Pause eingefgt damit Zeit zum Kopieren
' Bleibt.
'If Pind.1 = 0 Then Waitms 500

If Pind.1 = 0 Then Minute = 0
If Pind.1 = 0 Then Zeit = Eprom_zeit


'------------------
' Ton ein / Ausschalten
If Pind.3 = 0 Then Toggle T
If Pind.3 = 0 Then Waitms 200

If T = 1 Then Ton = "An "
If T = 0 Then Ton = "Aus"





' ------------------

  Gosub Anzeige


If Led_anzeige <> Timer0 Then Portd.5 = 1 Else Portd.5 = 0
If Led_anzeige <> Timer0 And T = 1 Then Gosub Tonausgabe



       Loop
 Return
'###############################################################################
'-------------------  T i m e r 0   I n t e r r u p p t  R o u t i n e ---------
Timer_null:
Incr Ueberlaufwert       ' Hier wird bei jedem berlauf, also nach jeweils 255
' Impulse der berlaufwert um eins erhht.
Zaehlwert_neu = Ueberlaufwert_neu + Zaehlwert
Ueberlaufwert_neu = Ueberlaufwert * 255








Return


'-------------------- T i m e r 1   I n t e r r u p p t  R o u t i n e ---------
Timer_eins:
Incr Sekunden
If Sekunden = 60 Then Gosub Minuten
Timer1 = Voreinstellung
Return
'-------------------- D i s p l a y   A n z e i g e  -------------------------
Anzeige:
Cls
Locate 1 , 1
Lcd Z

'Locate 1 , 5
'Lcd " Takte"



Locate 1 , 12
Lcd "T=" ; Ton


'Locate 1 , 10
'Lcd "Impulse"

Locate 2 , 1
Lcd "noch"

Locate 2 , 6
Lcd Restzeit

Locate 2 , 13
Lcd "Min."

Waitms 800
Return
'--------------------- Z e i t e i  n s t e l l u n g  ------------------------
Zeit:
' Hier kann die Zeit ausgesucht werden , wie LANGE GEMESSEN WERDEN SOLL
' Die Zeit wird in Minuten angegeben



Do
Cls
If Pind.1 = 0 Then Incr Zeit
If Pind.3 = 0 Then Decr Zeit
If Pind.1 = 0 Or Pind.3 = 0 Then P = P -5 Else P = 200

If P < 100 Then P = 5

If Zeit < 1 Then Zeit = 1
If Zeit > 1440 Then Zeit = 1440

Loeschen = 60

Locate 1 , 1
Lcd "Einstellen"
Locate 2 , 1
Lcd Zeit ;
Locate 2 , 10
Lcd "Minuten"
Waitms 50

Waitms P
' Nach einstellung der Zeit , die Zeit im EProm speichern wenn
 If Pind.0 = 0 Then Waitms 5

 If Pind.0 = 0 Then Eprom_zeit = Zeit
If Pind.0 = 0 Then Nullen = Zeit

If Pind.0 = 0 Then Goto Programm
Loop

Return

'------------------------- M i n u t e n  -------------------------------------
Minuten:
Incr Minute              ' Minuten aufadieren
Sekunden = 0             ' Sekunden lschen damit wieder von Null angezeigt wird
Return
 '------------------------- Zeit erreicht ------------------------------------
Messende:
Cls
Do
Locate 1 , 1
Lcd Z
Locate 1 , 10
Lcd "Impulse"
Locate 2 , 1
Lcd "in "
Locate 2 , 4
Lcd Zeit
Locate 2 , 10
Lcd "Minuten"
Portd.5 = 1              ' Led Blau an
Waitms 6
Portd.5 = 0              ' Led Blau aus
 Waitms 500
 ' Bei Taste 1 zum Programm gehen damit Reset PORTA.0 ausgefhrt wird

 If Pind.1 = 0 Then Goto Programm

  Loop
Return
'------------------------------------------------------------------------------
 Tonausgabe:
 Sound Portb.1 , 1004 , 83





 Return
 '----------------------------------------------------------------------------